/* All Rights Reserved, Copyright (c) FUJITSU LIMITED 1998 */

#include	<iostream>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#ifdef OM_PC
#include <windows.h>
#endif /* OM_PC */

using std::cout;
using std::endl;

#include	"orb_cplus.h"
#include	"CosNaming_cplus.h"

#include	"simple.H"


/* ------------------------------------------------------------------------- */

void
print_any( const CORBA::Any &any )
{
	CORBA::TypeCode_ptr     _tc;
	CORBA::Environment      env;

	_tc = any.type();
	if( _tc->equal( _tc_ODsample_sample1, env ) ) {
		ODsample::sample1       *smp1;
		smp1 = (ODsample::sample1 *)any.value();
		cout << "smp1->para1 = " << smp1->para1 << endl;
		cout << "smp1->para2 = " << smp1->para2 << endl;
	}
	if( _tc->equal( _tc_ODsample_sample2, env ) ) {
		ODsample::sample2       *smp2;
		smp2 = (ODsample::sample2 *)any.value();
		cout << "smp2->para1 = " << smp2->para1 << endl;
		cout << "smp2->para2 = " << smp2->para2 << endl;
	}
	if( _tc->equal( _tc_ODsample_sample3, env ) ) {
		ODsample::sample3       *smp3;
		smp3 = (ODsample::sample3 *)any.value();
		cout << "smp3->para1 = " << smp3->para1 << endl;
		cout << "smp3->para2 = " << smp3->para2 << endl;
	}
}

int
main( int argc, char *argv[] )
{
	CORBA::ORB_ptr		orb;
	CosNaming::Name		*name;
	CosNaming::NameComponent *name_component;
	CosNaming::NameComponent_var *name_var;
	CORBA::Environment_ptr	env;

	int	current_argc = argc;

	env = new CORBA::Environment;

	try {
		orb = CORBA::ORB_init( current_argc, argv, FJ_OM_ORBid, *env );

		CORBA::Object_ptr	obj = orb->resolve_initial_references(
						CORBA_ORB_ObjectId_NameService,
						*env );

		if ( obj == NULL ){
			fprintf( stderr, "Not Found NameService\n" );
			return 1;
		}

		CosNaming::NamingContext_ptr
		NamingContext_obj = CosNaming::NamingContext::_narrow( obj );
		CORBA::release( obj );

		name_component = new CosNaming::NameComponent;
		name_component->id = (const CORBA::Char *)"ODsample::anytest";
		name_component->kind = (const CORBA::Char *)"";
		name_var = CosNaming::Name::allocbuf(1);
		name_var[0] = name_component;
		name = new CosNaming::Name(1, 1, name_var, CORBA_TRUE);
		obj = NamingContext_obj->resolve( *name, *env );
		CORBA::release( NamingContext_obj );
		delete name;

		ODsample::anytest_ptr	ap =
				ODsample::anytest::_narrow( obj );
		CORBA::release( obj );
		ODsample::anytest_var	av = ap;

		CORBA::Any *any1, *any2, *any3, *ret;
		ODsample::sample2 *smp2 = new ODsample::sample2;
		smp2->para1 = 'z';
		smp2->para2 = (float)0.001;
		any1 = new CORBA::Any( _tc_ODsample_sample2, smp2, CORBA_TRUE );
		any2 = NULL;
		ODsample::sample3 *smp3 = new ODsample::sample3;
		smp3->para1 = 'x';
		smp3->para2 = 0.0001;
		any3 = new CORBA::Any();
		any3->replace( _tc_ODsample_sample3, smp3, CORBA_TRUE );

		ret = av->op1( *any1, any2, *any3, *env );

		print_any( *any2 );
		print_any( *any3 );
		print_any( *ret );

		delete any1;
		delete any2;
		delete any3;
		delete ret;

	}
	catch( CORBA::SystemException   &se ) {
		printf( "SystemException raised!\n" );
		printf( "exception-id = %s\n", se.id() );
		printf( "minor = 0x%x\n", se.minor() );
		return 1;
	}
	catch( CORBA::Exception &e ) {
		printf( "Exception raised!\n" );
		printf( "exception-id = %s\n", e.id() );
		return 1;
	}

	delete env;

	return 0;
}
